'Liest alle Termine aus persoenlichem Outlook-Kalender aus und schreibt sie in eine CSV-Datei
'
'Variante 1: ALLE Termindefinitionen
'Variante 2: Alle fertig aufbereiteten Termine fr einen frei whlbaren Zeitraum
'
'VBscript / Windows Scripting Host
'grundsaetzlich: Es werden keine Daten (z.B. Body, Meetingpartner) ermittelt, die sicherheitskritisch sind und eine
'                Sicherheitsnachfrage ausloesen wuerden (bzw. alternativ weitergehende Techniken erfordern)
'                Es werden grundsaetzlich ALLE gespeicherten Termine bearbeitet (Vergangenheit...Zukunft)
' 
'(c) http://galupki.de Juergen Galupki,  19.11.2006, Outlook 2003, WSH 5.6, WinXP-SP2 



'Outlookkonto-Kram
Const olFolderCalendar = 9
Set olApp = CreateObject("Outlook.Application")
Set olNameSpace = olApp.GetNamespace("MAPI")
Set olCalendar = olNameSpace.GetDefaultFolder(olFolderCalendar)
Set olAppointment = olCalendar.Items


' *** Variante 1 ***************************************************************************************************

'CSV-Ausgabedatei-Kram
'Trennzeichen ist GENERELL das Semikolon ";", berschriftszeile in Datei ist enthalten
'Serientermine ggf. gegen Ende uneinheitlicher Aufbau je nach Typ spezifisch!
Dim fso, File, sText
Dim fsoT, FileT
Const ForWriting = 2


Set fso   = CreateObject("Scripting.FileSystemObject")
set File  = fso.OpenTextFile("Outlook_Termin_Definitionen.csv", ForWriting, true)  'Definitionen


'bei Serienterminen sind einzelne Felder (z.B. einzelne abweichende Termine) nochmals in Sub(-sub-)felder unterteilt
'Dabei werden folgende Trennzeichen benutzt (und ggf. aus Subject, Location etc. entfernt):
Const trenn1 = "^"  'trennt einzelne Ausnahmedatmer einer Terminserien gegeneinander ab
Const trenn2 = ""  'trennt die Felder einzelner Ausnahmen gegeneinander ab

   
    ueber = "EntryId;Subject;Location;Start;End;AllDayEvent;Duration;ReminderMinutes;" _
          & "Categories;Importance;MeetingStatus;ResponseStatus;Sensitivity;" _
          & "LastModificationTime;" _
          & "Serie;Ausnahmen;" _
          & "StartSerie;AllDayEvent_Time;EndSerie;Type;Monat_Interval;Day_Instanz;DayOfWeekMask"

    File.WriteLine(ueber)

    n = 0
    For Each olAppointment In olCalendar.Items
      With olAppointment
        n = n + 1

        wdhlg = ""      'Seriendefinitionsdaten
        ausnahmen = ""  'Ausnahmedatuemer
  
'zunaechst die Wiederholungsregeln auslesen
        If .IsRecurring Then                                                       'ja, Terminserie
          Set objPattern = .GetRecurrencePattern

             wdhlg = wdhlg_termin(objPattern, .AllDayEvent)                        'Eigenschaften mit Function lesen

             Set myException = objPattern.Exceptions
             If myException.Count > 0 Then                                         'Ausnahmedatuemer? 

                For ausnnr=1 To myException.Count 
                   If ausnnr > 1 Then ausnahmen = ausnahmen & trenn1

                   If myException.Item(ausnnr).Deleted Then
                      
                      ausnahmen = ausnahmen & "isDeleted" & trenn2 & myException.Item(ausnnr).OriginalDate 
                   
                   Else
                   
                      Subject  = Replace(myException.Item(ausnnr).AppointmentItem.Subject, ";", ",")
                      Subject  = Replace(Subject, trenn1, "_")
                      Subject  = Replace(Subject, trenn2, "_")
                      Location = Replace(myException.Item(ausnnr).AppointmentItem.Location, ";", ",")
                      Location = Replace(Location, trenn1, "_")
                      Location = Replace(Location, trenn2, "_")
                      
                      ausnahmen = ausnahmen & "isModified" & trenn2 & myException.Item(ausnnr).OriginalDate & trenn2 _
                                & myException.Item(ausnnr).AppointmentItem.Start & trenn2 _
                                & myException.Item(ausnnr).AppointmentItem.End & trenn2
                                
                      If myException.Item(ausnnr).AppointmentItem.AllDayEvent = True Then 
                         ade = "AllDayEvent"
                      Else
                         ade = ""
                      End If
                      ausnahmen = ausnahmen & myException.Item(ausnnr).AppointmentItem.Duration & trenn2 _
                                & ade & trenn2 _
                                & Subject & trenn2 _   
                                & Location             'kein check fuer Subject & Location ob evtl. gleich...
                                                       'Categories usw. schlabbern wir ganz!...
                   End If
                Next 'Ausnahme

             End If

        End If 'isRecurring
          
' das geht sicher auch eleganter
        x1 = Replace(.Subject, ";", ",")
        x1 = Replace(x1, trenn1, "_")
        x1 = Replace(x1, trenn2, "_")
        x2 = Replace(.Location, ";", ",")
        x2 = Replace(x2, trenn1, "_")
        x2 = Replace(x2, trenn2, "_")
        x3 = Replace(.Categories, ";", ",")
        x3 = Replace(x3, trenn1, "_")
        x3 = Replace(x3, trenn2, "_")

        If .AllDayEvent = True Then x4 = "AllDayEvent;" Else x4 = ";" End If
        If .IsRecurring = True Then x5 = "S" Else x5 = "" End If
          
        alles = .EntryId & ";" & x1 & ";" & x2 & ";" & .Start & ";" & .End & ";" & x4 & .Duration & ";" _
              & .ReminderMinutesBeforeStart & ";" &  x3 & ";"
              
        Select Case .Importance
           Case 2
                  alles = alles & "High;"
           Case 0
                  alles = alles & "Low;"
           Case 1
                  alles = alles & ";" ' Normal
        End Select
        
        Select Case .MeetingStatus
           Case 1
                  alles = alles & "Meeting;"
           Case 5
                  alles = alles & "MeetingCanceled;"
           Case 3
                  alles = alles & "MeetingReceived;"
           Case 0
                  alles = alles & ";"
        End Select
        
        Select Case .ResponseStatus
           Case 3
                  alles = alles & "accepted;"
           Case 4
                  alles = alles & "declined;"
           Case 0
                  alles = alles & ";" 'Normal
           Case 5
                  alles = alles & "notresponded;"
           Case 1
                  alles = alles & "organized;"
           Case 2
                  alles = alles & "tentative;"
        End Select
        
        Select Case .Sensitivity
           Case 3
                  alles = alles & "Confidential;"
           Case 0
                  alles = alles & ";"  ' Normal
           Case 1
                  alles = alles & "Personal;"
           Case 2
                  alles = alles & "Private;"
        End Select
 
 
        alles = alles & .LastModificationTime & ";" & x5 & ";" & ausnahmen & ";" & wdhlg
'evtl. interessant wre noch .EntryId (falls man die Termine zum synchronisieren nutzen mchte oder z.B. in eine
'DB einstellt, ggf. zusammen mit "Fremdterminen" usw.
              
        File.WriteLine(alles)
                                      
      End With
    Next 'olAppointment

    File.Close
    Set File = Nothing
    Set fso = Nothing


' *** Variante 2 ***************************************************************************************************
'Terminliste absolut 
'(Nachteil: In der Summe mehr Daten; es fehlen Zusammenhnge zwischen Terminen; es fehlen Daten (z.B. Ur-Starttermin,
'           interessant z.B. zur Berechnung Alter bei Jahrestagen; kaum Chancen zum re-import (Synchronisation)...)
'(Vorteil:  VIEL weniger Aufwand)
  
    Set fsoT  = CreateObject("Scripting.FileSystemObject")
    Set FileT = fsoT.OpenTextFile("Outlook_Termin_Liste.csv", ForWriting, true)      'fertig aufbereitete Terminliste
  
  
    tdystart = "01.01." & Year(Now)   '-1  '1.1.   Vorjahr
    tdyend   = "31.12." & Year(Now)   '+1  '31.12. Folgejahr
    
    
    ueber = "EntryId;Subject;Location;Categories;Start;End;AllDayEvent;Duration;ReminderMinutes;" _
          & "LastModificationTime;Importance;MeetingStatus;ResponseStatus;Sensitivity;"

    FileT.WriteLine(ueber)
  
    Set olAppointment = olNameSpace.GetDefaultFolder(olFolderCalendar).Items
    
    olAppointment.Sort "[Start]"
    olAppointment.IncludeRecurrences = True

    Set currentAppointment = olAppointment.Find("[Start] >= """ & tdystart & """ and [Start] <= """ & tdyend & """")

    While TypeName(currentAppointment) <> "Nothing"
       alles = ausgabe(currentAppointment)
       FileT.WriteLine(alles)
       Set currentAppointment = olAppointment.FindNext
    Wend
    
    FileT.Close
    Set FileT = Nothing
    Set fsoT = Nothing

'===================================================================================================================

    Set olAppointment = Nothing
    Set olCalendar = Nothing
    Set olNameSpace = Nothing
    Set olApp = Nothing
    Set currentAppointment = Nothing
    
'   Wscript.Echo "Insgesamt " & n & " Eintrge.", vbInformation, "Fertig"


'===================================================================================================================


Function wdhlg_termin(objPattern, isAllDayEvent) 'noetig fuer Variante 1
'ermittelt den Typ einer Terminserie und stellt die je nach Typ notwendigen Felder zur Verfgung
'===========================================================================
'WIEDERHOLUNGSTERMINE
'RecurrenceTyp    Eigenschaften      Beispiel 
'===========================================================================
'0 olRecursDaily    Interval           Alle N Tage 
'                   DayOfWeekMask      Jeden Dienstag, Mittwoch und Donnerstag 
'  
'2 olRecursMonthly  Interval           Alle N Monate 
'                   DayOfMonth         Der N-te Tag im Monat 
'                  
'3 olRecursMonthNth Interval           Alle N Monate 
'                   Instance           Der N-te Dienstag 
'                   DayOfWeekMask      Jeden Dienstag und Mittwoch 
'                   
'1 olRecursWeekly   Interval           Alle N Wochen 
'                   DayOfWeekMask      Jeden Dienstag, Mittwoch und Donnerstag 
'  
'5 olRecursYearly   DayOfMonth         Der N-te Tag im Monat 
'                   MonthOfYear        Februar 
'  
'6 olRecursYearNth  Instance           Der N-te Dienstag 
'                   DayOfWeekMask      Dienstag, Mittwoch, Donnerstag 
'                   MonthOfYear        Februar 
'===========================================================================
'Instance         1-4(5), 6=Letzter
'DayOfWeekMask Or 1=So, 2=Mo, 4=Di, 8=Mi, 16=Do, 32=Fr, 64=Sa
'DayOfMonth       1-31
'MonthOfYear      1-12
'NoEndDate        true/false
'PatternStartDate Datum
'PatternEndDate   Datum oder... 
'Occurrences      ...Anzahl von Wiederholungen
'===========================================================================

       wdhlg = ""
       wdhlg = wdhlg  & objPattern.PatternStartDate & ";" 
       If isAllDayEvent Then wdhlg = wdhlg & "AllDayEvent;" Else wdhlg = wdhlg & objPattern.StartTime & ";" 
       wdhlg = wdhlg & objPattern.PatternEndDate & ";"

       Select Case objPattern.RecurrenceType

            Case 0 'taeglich
                If objPattern.Interval = 1 Then
                   wdhlg = wdhlg & "DAIYLY;;"
                Else
                   wdhlg = wdhlg & "PERIOD;" & objPattern.Interval
                End If

            Case 1 'woechentlich oder taeglich an Arbeitstagen (Interval=0)
                wdhlg = wdhlg & "WEEKLY;"
                If objPattern.Interval < 1 Then wdhlg = wdhlg & "1;;" Else wdhlg = wdhlg & objPattern.Interval & ";;"
                If objPattern.DayOfWeekMask And  2 Then wdhlg = wdhlg & "M" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  4 Then wdhlg = wdhlg & "D" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  8 Then wdhlg = wdhlg & "M" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 16 Then wdhlg = wdhlg & "D" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 32 Then wdhlg = wdhlg & "F" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 64 Then wdhlg = wdhlg & "S" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  1 Then wdhlg = wdhlg & "S" Else wdhlg = wdhlg & "-"

            Case 2 'monatlich
                wdhlg = wdhlg & "MONTHLY;" & objPattern.Interval & ";" & objPattern.DayOfMonth 
                
            Case 3 'monatlich nth
                wdhlg = wdhlg & "MONTHLYnTH;" & objPattern.Interval & ";" 
                
                If objPattern.Instance > 4 Then wdhlg = wdhlg & "L;" Else wdhlg = wdhlg & objPattern.Instance & ";"

                If objPattern.DayOfWeekMask And  2 Then wdhlg = wdhlg & "M" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  4 Then wdhlg = wdhlg & "D" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  8 Then wdhlg = wdhlg & "M" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 16 Then wdhlg = wdhlg & "D" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 32 Then wdhlg = wdhlg & "F" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 64 Then wdhlg = wdhlg & "S" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  1 Then wdhlg = wdhlg & "S" Else wdhlg = wdhlg & "-"

            Case 4

            Case 5 'jhrlich tt.mm.
                wdhlg = wdhlg & "YEARLY;" & objPattern.MonthOfYear & ";" & objPattern.DayOfMonth
                
            Case 6 'jhrlich 
                wdhlg = wdhlg & "YEARLYnTH;" 
                wdhlg = wdhlg & objPattern.MonthOfYear & ";"
                If objPattern.Instance > 4 Then wdhlg = wdhlg & "L;" Else wdhlg = wdhlg & objPattern.Instance & ";"

                If objPattern.DayOfWeekMask And  2 Then wdhlg = wdhlg & "M" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  4 Then wdhlg = wdhlg & "D" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  8 Then wdhlg = wdhlg & "M" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 16 Then wdhlg = wdhlg & "D" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 32 Then wdhlg = wdhlg & "F" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And 64 Then wdhlg = wdhlg & "S" Else wdhlg = wdhlg & "-"
                If objPattern.DayOfWeekMask And  1 Then wdhlg = wdhlg & "S" Else wdhlg = wdhlg & "-"
            
        End Select

        wdhlg_termin = wdhlg

End Function

'===================================================================================================================

Function ausgabe(olAppointment) 'noetig fuer Variante 2

  With olAppointment
  
    alles = .EntryId & ";" & Replace(.Subject, ";", ",") & ";" & Replace(.Location, ";", ",") & ";" _
          & Replace(.Categories, ";", ",") & ";" & .Start & ";" & .End & ";" & .AllDayEvent & ";" _
          & .Duration & ";" & .ReminderMinutesBeforeStart & ";" & .LastModificationTime & ";"
    
        Select Case .Importance
           Case 2
                  alles = alles & "High;"
           Case 0
                  alles = alles & "Low;"
           Case 1
                  alles = alles & ";" ' Normal
        End Select
        
        Select Case .MeetingStatus
           Case 1
                  alles = alles & "Meeting;"
           Case 5
                  alles = alles & "MeetingCanceled;"
           Case 3
                  alles = alles & "MeetingReceived;"
           Case 0
                  alles = alles & ";"
        End Select
        
        Select Case .ResponseStatus
           Case 3
                  alles = alles & "accepted;"
           Case 4
                  alles = alles & "declined;"
           Case 0
                  alles = alles & ";" 'Normal
           Case 5
                  alles = alles & "notresponded;"
           Case 1
                  alles = alles & "organized;"
           Case 2
                  alles = alles & "tentative;"
        End Select
        
        Select Case .Sensitivity
           Case 3
                  alles = alles & "Confidential;"
           Case 0
                  alles = alles & ";"  ' Normal
           Case 1
                  alles = alles & "Personal;"
           Case 2
                  alles = alles & "Private;"
        End Select
  
  
  
        ausgabe = alles
        
  
  End With

End Function 'ausgabe

'===================================================================================================================
'===== ENDE ========================================================================================================
'===================================================================================================================


'als VBA wren einige nderungen notwendig:
'Dim s As String
'Dim d As Date
'Dim t As Date
'Dim ts As String
'Dim n As Integer
'Dim olApp As Outlook.Application
'Dim olNameSpace As Outlook.NameSpace
'Dim olCalendar As Outlook.MAPIFolder
'Dim olAppointment As Outlook.AppointmentItem
'Set olApp = CreateObject("Outlook.Application") 'oder New Outlook.Application
'Set olNameSpace = olApp.GetNamespace("MAPI")
'Set olCalendar = olNameSpace.GetDefaultFolder(olFolderCalendar)
'ausserdem: Wscript.Echo ersetzen durch Prints; Ausgabe in Datei z.B. durch Open/Print #...
'...


'===================================================================================================================


'Minidoku
'Subject			Betreff
'Location			Ort
'Start				Beginndatum und ggf. (nicht immer!) Uhrzeit  tt.mm.jjjj hh:mm - betrifft auch alle anderen DatFelder
'End				Endedatum und ggf. Uhrzeit - der 31.12.4500  23:59:00 scheint das "Highdate" zu sein (=ohne Ende)
'AllDayEvent		AllDayEvent (ganztgig) oder leer
'Duration			Dauer in Minuten
'ReminderMinutes	Erinnern x Minuten vor dem Termin
'Categories			Kategorien, getrennt durch Komma(!)
'Importance			Wichtigkeit/Prio, sofern abweichend von Normal
'MeetingStatus		Status des Meetings
'ResponseStatus		Antworten auf Meeting-Anfrage
'Sensitivity		Vertraulichkeit (z.B. "Privat"-Schalter)
'LastModificationTime	zuletzt gendert am...

'Serie				S, wenn Serientermin, genau wie alle folgenden Felder nur fr Terminserien relevant seind:

'Ausnahmen			zu/von einer Serie (gelscht oder gendert) nach folgendem Schema:
'Trenn1 ^ trennt einzelne Ausnahmeregeln einer Serie
'Trenn2  trennt die Felder einer Ausnahme
'isDeleted21.12.2006^...											... an diesem Tag findet die Terminserie nicht statt
'isModifiedDatumStartEndDurationAllDayEventSubjectLocation^	... an diesem Tag ist etwas anders

'StartSerie			Startdatum der Terminserie
'AllDayEvent_Time	AllDayEvent oder Startzeit
'EndSerie			Endedatum der Terminserie
'Type				Typ der Wiederholung:		 DAILY   PERIOD   WEEKLY   MONTHLY   MONTHLYnTH  YEARLY   YEARLYnTH
'Monat_Interval		Monat oder Intervall		   -     Tage    Interval  Interval   Interval   Monat    Monat
'Day_Instanz		Tag oder Instanznummer		   -       -        -        Tag      1-4/L (Wo)  Tag     1-4/L (Wo)
'DayOfWeekMask      Maske betroffener Wochentage   -       -       Maske      -         Maske      -      Maske


'weitere Erklrungen
'===================
'Interval:   Gibt das regelmige Intervall an, z.B. bei Wochenterminen ist 1=jede Woche, 2=alle zwei Wochen...
'1-4/L (Wo): Gibt bezogen auf den Wochentag die n.te Woche im Monat an (L=letzte)
'Maske:      Siebenstelliges Feld (Montag-Sonntag), "MDMDF--" z.B. wre Montags-Freitags, "---D---" wre Donnerstags...
'isModified: Beachten, dass auch andere Felder gendert sein knnten (z.B. Meeting..., Categories...)


'Sicherheitswarnung: Sollte nicht erscheinen. Nimmt man aber derartige Felder noch auf (z.B. .Body, .Recipients...),
'                    wrde eine Dialogabfrage seitens Outlook gestartet (...Zugriff ... gewhren...)

